﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

namespace PhoneAppLLS
{
    public partial class MainPage : PhoneApplicationPage
    {
        public MainPage()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Redisplay the current vault
        /// </summary>
        private void ShowVault()
        {
            longListSelectorVaultEntries.ItemsSource = new AGroupedVaultEntry();
            longListSelectorVaultEntries.SelectedItem = null;
        }

        private void buttonAdd_Click(object sender, EventArgs e)
        {
            DataAccessLayer DAL = (Application.Current as App).DAL;

            if (DAL.IsTrial)
            {
                if (DAL.VaultEntries.Count >= DataAccessLayer.IsTrialLimit)
                {
                    MessageBox.Show(string.Format("The Trial version only allows {0} entries.  Please purchase a full version or delete an existing entry", DataAccessLayer.IsTrialLimit));
                    return;
                }
            }

            this.NavigationService.Navigate(new Uri("/EditEntry.xaml?type=new", UriKind.Relative));
        }

        private void buttonOptions_Click(object sender, EventArgs e)
        {
            // now show the editor to allow CRUD on the existing entries
            this.NavigationService.Navigate(new Uri("/Options.xaml", UriKind.Relative));
        }

        private void OnLoaded(object sender, RoutedEventArgs e)
        {
            DataAccessLayer DAL = (Application.Current as App).DAL;

            // when the page is being resumed this event will fire but it's not
            // appropriate to display the info as we actually want to hide it.
            if (DAL.ResumeFromDeactivation)
            {
                return;
            }

            // if the key has changed then reload the value entries
            if (DAL.ListReloadRequired || longListSelectorVaultEntries.ItemsSource == null)
            {
                ShowVault();

                DAL.ListReloadRequired = false;
            }
        }

        private void OnSelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            // edit the selected item
            VaultEntry entry = (VaultEntry)longListSelectorVaultEntries.SelectedItem;
            if (entry == null) return;

            longListSelectorVaultEntries.SelectedItem = null;

            // pass the get to NewItem so that it can be looked up
            this.NavigationService.Navigate(new Uri(string.Format("/EditEntry.xaml?type=edit&key={0}", entry.Caption), UriKind.Relative));
        }
    }
}